@ECHO OFF
REM Modified 27-01-1993 by Lourens Post (TRC)
REM Modified by Steve Richardson     12/96
REM
REM Set the environment variable to the shared drive

REM
ECHO HB============== Start of HEGABOX batch file ================
REM
REM ----check at least one input argument; if not, terminate
REM
IF NOT %1.==. GOTO ARGOK
ECHO   Run model HEGABOX with 1 to n input files as required.
ECHO   Parameters should be entered as follows :-
ECHO    1 to n-1  input files to be concatenated, with file names
ECHO              of the form FILENAME.EXT
ECHO    n         identifier for this run, with file name
ECHO              of the form FILENAME     (N.B. NO EXTENSION)
ECHO              (system assumes extension .HBI, and uses/creates
ECHO              (files with this name and various extensions).
ECHO    if n=1    the file must already exist with the extension .HBI,
ECHO              but the extension must not be included.
ECHO    if n=2    the first file must already exist with its specified
ECHO              extension, and the file will be copied to the
ECHO              second file (system assumes extension .HBI).
ECHO    else      n-1 files must already exist with their specified
ECHO              extensions, and they will be concatenated and copied
ECHO              to the n'th file (system assumes extension .HBI).
ECHO   One of the two basic HEGABOX input files STPOOLNO.HBI, and
ECHO   STPOOLHF.HBI can be copied from
ECHO   %HGSYSTEM%\STINPUT as a template for an input data file *.HBI.
GOTO EXIT
:ARGOK
REM
REM ----SHIFT eliminates first argument and moves all others down one
REM
SHIFT
REM
REM ----check if only one input argument specified
REM
IF NOT %1.==. GOTO NUMARGS
REM
REM ----one argument; check if the input file exists
REM ----if yes, check data dictionary; if not, terminate
REM
IF EXIST %0.HBI GOTO CHECKDD
ECHO HEGABOX - Input file %0.HBI does not exist - program terminated
GOTO EXIT
:NUMARGS
REM
REM ----check if only two input arguments specified
REM
IF NOT %2.==. GOTO CONCAT
REM
REM ----two arguments; check if first file exists; if not, terminate
REM
IF EXIST %0 GOTO COPY1
ECHO HEGABOX - Input file %0 does not exist - program terminated
GOTO EXIT
:COPY1
REM
REM ----copy file, do not concatenate, check data dictionary
REM
copy /b %0 %1.HBI > NUL:
SHIFT
GOTO CHECKDD
:CONCAT
REM
REM ----more than two arguments; create CONCAT key in temporary file
REM
ECHO = CONCAT == > $CONCAT$.HBI
:CHECKN
REM
REM ----check if input file exists; if not, terminate
REM
IF EXIST %0 GOTO COPYN
ECHO HEGABOX - Input file %0 does not exist - program terminated
IF EXIST $CONCAT$.HBI DEL $CONCAT$.HBI
GOTO EXIT
:COPYN
REM
REM ----copy input file at end of temporary file
REM
copy /b $CONCAT$.HBI+%0 > NUL:
REM
REM ----is there another file to concatenate?
REM
SHIFT
IF NOT %1.==. GOTO CHECKN
REM
REM ----no more files to concatenate; copy to final file
REM
copy /b $CONCAT$.HBI %0.HBI > NUL:
IF EXIST $CONCAT$.HBI DEL $CONCAT$.HBI
:CHECKDD
REM
REM ----check if preprocessed data dictionary exists; if not, terminate
REM
IF EXIST %HGSYSTEM%\DICT.HBD GOTO DICTOK
ECHO DICT.HBD data dictionary does not exist - program terminated
GOTO EXIT
:DICTOK
REM
REM ----delete all files which might be generated during HEGABOX run
REM
IF EXIST %0.HBE DEL %0.HBE >NUL:
IF EXIST %0.HBR DEL %0.HBR >NUL:
IF EXIST %0.HBO DEL %0.HBO >NUL:
IF EXIST %0.HTL DEL %0.HTL >NUL:
IF EXIST %0.MMO DEL %0.MMO >NUL:
REM
REM ----make a copy of the free-format input file
REM
copy /b %0.HBI %0.TMI > NUL
REM
REM ---- copy name of analysis to file (to set file names in FFMAIN)
REM
ECHO %0 > HGSYST$$.TIT
ECHO HBI >> HGSYST$$.TIT
ECHO %HGSYSTEM%\DICT.HBD >> HGSYST$$.TIT
REM Input: HGSYST$$.TIT, %HGSYSTEM%\DICT.HBD, %0.TMI
REM Output: %0.HBI, %0.HBF, %0.HBU
REM         %0.TME (in case of errors)
 %HGSYSTEM%\FFMAIN 
REM ----erase temporary files
REM
IF EXIST HGSYST$$.TIT DEL HGSYST$$.TIT
IF EXIST %0.TMI DEL %0.TMI
IF EXIST %0.HBF DEL %0.HBF
REM
REM ----erase temporary files
REM
IF EXIST HGSYST$$.TIT DEL HGSYST$$.TIT
IF EXIST %0.TMI DEL %0.TMI > NUL
IF EXIST %0.HBF DEL %0.HBF > NUL
REM
REM ----check if error file exists
REM
IF EXIST %0.HBE GOTO HBERR
IF NOT EXIST %0.TME GOTO FFOK
ECHO Input errors exist - check input file - program terminated
IF EXIST %0.TME DEL %0.TME > NUL
IF EXIST %0.HBU DEL %0.HBU > NUL
GOTO EXIT
:FFOK
REM
REM ----check if unformatted input file exists; if not, terminate
REM
IF EXIST %0.HBU GOTO UNFOK
ECHO Unformatted input file not available - program terminated
GOTO EXIT
:UNFOK
ECHO HEGABOX calculations are being performed
REM
REM ---- copy name of analysis to file (to set file names in HBMAIN)
REM
ECHO %0 > HGSYST$$.TIT
ECHO HBI >> HGSYST$$.TIT
ECHO %HGSYSTEM%\DICT.HBD >> HGSYST$$.TIT
REM Input: HGSYST$$.TIT, %0.HBU
REM Output: %0.HBR , %0.HBO etc

%HGSYSTEM%\HBMAIN 

rem RUN77 D:\HEGABOX\HBMAIN /BREAK

REM
REM ----erase temporary files
REM
IF EXIST HGSYST$$.TIT DEL HGSYST$$.TIT
IF EXIST %0.HBU DEL %0.HBU
IF EXIST %0.HBE GOTO HBERR
GOTO HBCONT
:HBERR
ECHO ***** ERRORS ***** have been found during HEGABOX run
ECHO See the file %0.HBE for list of errors
ECHO HB--------------------------------------------------------
:HBCONT
ECHO End of HEGABOX
IF EXIST %0.HBR ECHO Output in report file %0.HBR
IF EXIST %0.HBO ECHO Observer data for HEGADAS-T in (formatted) file %0.HBO
IF EXIST %0.HTL ECHO HEGADAS-T input data in link file %0.HTL
IF EXIST %0.MMO ECHO Info on MMES options in file %0.MMO
:EXIT
ECHO HB============== End of HEGABOX batch file ================
